﻿package
{
	import flash.display.Sprite;
	import flash.display.StageQuality;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import supermotion3d.*;
	import models.*;

	public class Main extends Sprite
	{
		//コンテナ
		private var _container:Sprite = new Sprite();
		//3Dオブジェクト
		private var objects:Array = new Array();
		//カメラ
		private var _camera:Camera3D = new Camera3D();
		//シーン
		private var _scene:Scene3D;
		//キー入力
		private var _keyRight   : Boolean = false;
		private var _keyLeft    : Boolean = false;
		private var _keyForward : Boolean = false;
		private var _keyBackward: Boolean = false;

        public function Main():void
        {
			var i:int;
			//画質を中に設定
			stage.quality = StageQuality.MEDIUM;
			//ウィンドウサイズが変更されてもステージの内容は定義済みのサイズのまま
			stage.scaleMode = StageScaleMode.NO_SCALE;
			//Flashを画面左上に吸着させる
			stage.align = StageAlign.TOP_LEFT;
			//コンテナ追加
			this.addChild(_container);
			//シーン作成
			_scene = new Scene3D(_container);
			//騎士モデル追加
			for ( i = 0; i < 4; i++ )
			{
				//TransMotionからmodelsフォルダに書き出したクラスをここに
				objects[i] = new Majo(this);
				_scene.addChild(objects[i]);
				objects[i].position = new Vector3D((i%2)*400-200,0,Math.floor((i/2)%2)*400-200);
				//オブジェクトをボタンに、カーソルで指すとハンドカーソルに
				objects[i].buttonMode = true;
				//オブジェクトをクリックできるように
				objects[i].addEventListener(MouseEvent.CLICK, objClicked);
			}

			onStageResize(null);

			//30fpsなら1秒間に30回呼び出す関数を設定
            addEventListener(Event.ENTER_FRAME, renderScene);
			//画面サイズが変更されたら
            stage.addEventListener(Event.RESIZE, onStageResize);
			//キーが押されたら
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			//キーが離されたら
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
    	}

		//30fpsなら1秒間に30回呼び出す関数
        private function renderScene(e:Event):void 
        {
			//カメラ位置
			_camera.position = new Vector3D(-800,-400,-800);
			//カメラ注視点
			_camera.lookAt = new Vector3D(0,0,0);

			//キーボードでモデル移動
			for each(var obj:Model3D in objects )
			{
				//キー操作
				if ( _keyLeft )
				{
					obj.rotateY -= 10;
					if ( obj.rotateY < 0 )
					{
						obj.rotateY += 360;
					}
				}
				if ( _keyRight )
				{
					obj.rotateY += 10;
					if ( obj.rotateY >= 360 )
					{
						obj.rotateY -= 360;
					}
				}
				var radian:Number = obj.rotateY / 180 * Math.PI;
				if ( _keyForward )
				{
					obj.positionX -= Math.sin(radian)*10;
					obj.positionZ -= Math.cos(radian)*10;
				}
				if ( _keyBackward )
				{
					obj.positionX += Math.sin(radian)*10;
					obj.positionZ += Math.cos(radian)*10;
				}
			}
			//シーンレンダリング
			_scene.render(_camera);
        }

		//オブジェクトがクリックされたら
		private function objClicked(event:MouseEvent):void
		{
			var obj:Model3D = event.target as Model3D;
//			_scene.removeChild(obj);
//			obj.visible = false;
//			obj._stopAnimation = !obj._stopAnimation;
			obj.currentAnimation++;
		}

		//キーが押されたら
		private function keyDownHandler( event :KeyboardEvent ):void
		{
			switch ( event.keyCode )
			{
				case "W".charCodeAt() :
				case Keyboard.UP :
					_keyForward = true;
					_keyBackward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					_keyBackward = true;
					_keyForward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					_keyLeft = true;
					_keyRight = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					_keyRight = true;
					_keyLeft = false;
					break;
			}
		}

		//キーが離されたら
		private function keyUpHandler( event :KeyboardEvent ):void 
		{
			switch ( event.keyCode ) 
			{
				case "W".charCodeAt() :
				case Keyboard.UP :
					_keyForward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					_keyBackward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					_keyLeft = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					_keyRight = false;
					break;
			}
		}

		//画面サイズが変更されたら
        private function onStageResize(event:Event):void
        {
			this._container.x = stage.stageWidth/2;
			this._container.y = stage.stageHeight/2;
		}
    }
}
